# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class AttestationMechanism(Model):
    """Attestation mechanism for individualEnrollment as well as enrollmentGroup.

    All required parameters must be populated in order to send to Azure.

    :param type: Required. Attestation Type. Possible values include: 'none',
     'tpm', 'x509', 'symmetricKey'
    :type type: str or ~protocol.models.enum
    :param tpm: TPM attestation method.
    :type tpm: ~protocol.models.TpmAttestation
    :param x509: X509 attestation method.
    :type x509: ~protocol.models.X509Attestation
    :param symmetric_key: Symmetric Key attestation method.
    :type symmetric_key: ~protocol.models.SymmetricKeyAttestation
    """

    _validation = {"type": {"required": True}}

    _attribute_map = {
        "type": {"key": "type", "type": "str"},
        "tpm": {"key": "tpm", "type": "TpmAttestation"},
        "x509": {"key": "x509", "type": "X509Attestation"},
        "symmetric_key": {"key": "symmetricKey", "type": "SymmetricKeyAttestation"},
    }

    def __init__(self, *, type, tpm=None, x509=None, symmetric_key=None, **kwargs) -> None:
        super(AttestationMechanism, self).__init__(**kwargs)
        self.type = type
        self.tpm = tpm
        self.x509 = x509
        self.symmetric_key = symmetric_key
